package design_pattern.adapter;

import java.util.Enumeration;
import java.util.Iterator;

public class IteratorAdapter<T> implements Enumeration<T> {
	private Iterator<T> delegator;

	public IteratorAdapter(Iterator<T> delegator) {
		this.delegator = delegator;
	}

	public boolean hasMoreElements() {
		return delegator.hasNext();
	}

	public T nextElement() {
		return delegator.next();
	}
}
