package design_pattern.intercepting_filter;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

public class LoggingFilter implements Filter {

	public void doFilter(ServletRequest request,
			ServletResponse response, FilterChain filterChain)
			throws IOException, ServletException {

		try {
			requestLog(request);
			filterChain.doFilter(request, response);
		} finally {
			responseLog(response);
		}
	}

	private void requestLog(ServletRequest request) {
		System.out.println("requestLog");
	}

	private void responseLog(ServletResponse response) {
		System.out.println("responseLog");
	}

	public void init(FilterConfig config)
			throws ServletException {
	}

	public void destroy() {
	}
}
