package design_pattern.singleton;

public abstract class Singleton {
	private static Singleton instance = null;

	protected Singleton() {
	}

	public static synchronized Singleton getInstance() {
		if (instance != null) {
			return instance;
		}
		String className = System.getProperty("SingletonClass");
		try {
			instance = (Singleton) Class.forName(className)
					.newInstance();
			return instance;
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	public void foo() {
		System.out.println("Foo");
	}
}
