package design_pattern.singleton;

import java.util.HashMap;
import java.util.Map;

public class ThreadLocalSample {
	private static final ThreadLocal<Map<String, String>> TEMP_VAL = new ThreadLocal<Map<String, String>>() {
		@Override
		protected Map<String, String> initialValue() {
			return new HashMap<String, String>();
		}
	};

	public static void main(String[] args) throws Exception {
		put();
		print();

		new Thread() {
			@Override
			public void run() {
				print();
			}
		}.start();

		Thread.sleep(100);

		print();
	}

	private static void put() {
		Map<String, String> map = TEMP_VAL.get();
		print();

		map.put("foo", "foo");
		map.put("bar", "bar");
		print();
	}

	private static void print() {
		Map<String, String> map = TEMP_VAL.get();
		System.out.println(Thread.currentThread().getName()
				+ " " + map);
	}
}
